/*============================================================================
//	aPCI-R47̒`
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	{{[h͂`ohbQP𓋍ڂĂ܂
//
//==========================================================================*/
#if !defined(_APCI47_H)
#define _APCI47_H

#ifndef _TYPEDEF_H
	#include "typedef.h"
#endif

#ifndef _APCISRVS_H
	#include "apcisrvs.h"
#endif

#ifndef _APCICTRL_H
	#include "apcictrl.h"
#endif

/*==========================================*/
/*	aPCI-R47 card's relative port address	*/
/*==========================================*/
#define	APCI47_PORT_1	0
#define	APCI47_PORT_2	1

/*==================*/
/*	Miscellaneous	*/
/*==================*/
#define	APCI47_MAX_SLOTS	16			/* Maximum number of slots */
#define APCI47_MAX_PORTS	2			/* Maximum number of user ports */

/*==============*/
/*	Device ID	*/
/*==============*/
#define	APCI47_BOARD_ID		0x9047		/* pci bus device id */
#define	APCI47_VENDOR_ID	0x136c		/* pci bus vendor id */
										/* our device id */
#define	APCI47_DEVICE_ID	( ( DWORD )APCI47_BOARD_ID\
							| ( ( DWORD )APCI47_VENDOR_ID << 16 ) )

#endif
