//============================================================================
//	apci47w.pas
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	V1.11 Date 1999/07/30
//
//============================================================================

unit apci47w;

interface

uses
	Windows;

//-------------------------------------
// װޒ萔
//-------------------------------------
const
	APCI47_SUCCESS				      = 0;	// I
	APCI47_ERR_SYSTEM			      = 1;	// GetLastError sĂ
	APCI47_ERR_NO_DEVICE		    = 2;	// gp\޲Ȃ
	APCI47_ERR_IN_USE			      = 3;	// w肳ꂽ޲͎gp
	APCI47_ERR_INVALID_SLOT		  = 4;  // Ș_ۯĔԍw肵
	APCI47_ERR_RESOURCE			    = 5;	// ؿװ
	APCI47_ERR_INVALID_PORT     = 6;	// ߰Ăv
	APCI47_ERR_INVALID_ARGUMENT = 7;	// Ȉv
	APCI47_ERR_NO_CREATE				= 8;	// ޲شĂĂ܂
	APCI47_ERR_WRAPDLL 					=Dword(-1); 	// ׯ߰֐װ
//-------------------------------------
// ߰Ĕԍ萔
//-------------------------------------
	APCI47_PORT_1 =	0;
	APCI47_PORT_2 = 1;
//-------------------------------------
// ̑萔
//-------------------------------------
	APCI47_DLL_NAME 	= 'apci47.dll';	// DLĻٖ
	APCI47_MAX_PORTS	= 2;						// ߰Đ
	APCI47_MAX_SLOTS	= 16;						// őۯĐ
	APCI47_DEVICE_ID	= $136c9047;		// ޲ID
	APCI47_SLOT_AUTO	= $ffff;				// AutoSlotl
//-------------------------------------
// ؿ\
//-------------------------------------
	APCI47_MAX_MEM	=	 9;
	APCI47_MAX_IO		= 20;
	APCI47_MAX_IRQ	=	 7;
	APCI47_MAX_DMA	=	 7;

type
	TAPCI47RESOURCE = record
		dwNumMemWindows:																DWORD;	// س޳(gp)
		dwMemBase:			array [1 .. APCI47_MAX_MEM] of	DWORD;	// س޳ްڽ(gp)
		dwMemLength:		array [1 .. APCI47_MAX_MEM] of	DWORD;	// س޳(gp)
		dwMemAttrib:		array [1 .. APCI47_MAX_MEM] of	DWORD;	// س޳(gp)
		dwNumIOPorts:																		DWORD;	// I/O߰Đ
		dwIOPortBase:		array [1 .. APCI47_MAX_IO] of		DWORD;	// I/O߰ްڽ
		dwIOPortLength: array [1 .. APCI47_MAX_IO] of		DWORD;	// I/O߰Ē
		dwNumIRQs:																			DWORD;	// IRQ(gp)
		dwIRQRegisters: array [1 .. APCI47_MAX_IRQ] of	DWORD;	// IRQؽ(gp)
		dwIRQAttrib:		array [1 .. APCI47_MAX_IRQ] of	DWORD;	// IRQؽ(gp)
		dwNumDMAs:																			DWORD;	// DMAِ(gp)
		dwDMALst:				array [1 .. APCI47_MAX_DMA] of	DWORD;	// DMAؽ(gp)
		dwDMAAttrib:		array [1 .. APCI47_MAX_DMA] of	DWORD;	// DMAّؽ(gp)
		dwReserved1:		array [1 .. 3] of								DWORD;	// \(gp)
	end;
//-------------------------------------
// J֐
//-------------------------------------
// DLL ۰
function Apci47wDllOpen: Boolean;
// DLL ۰
function Apci47wDllClose: Boolean;
// aPCI-R47 DLL,޲ײްްޮݔԍ擾
function Apci47wGetVersion(var pdwDllVersion:DWord; var pdwDriverVersion:DWord): Boolean;
// CӂaPCI-R47̎gp錾
function Apci47wCreate(var pwLogSlot:Word): Boolean;
// CӂaPCI-R47̎gpJ
function Apci47wClose(wLogSlot:Word): Boolean;
// ؿ擾
function Apci47wGetResource(wLogSlot:Word; var pResInfo:TAPCI47RESOURCE): Boolean;
// Cӂ߰Ăް
function Apci47wInPort(wLogSlot:Word; dwLogPort:DWord; var pbInValue:Byte): Boolean;
// Cӂ߰Ăްo
function Apci47wOutPort(wLogSlot:Word; dwLogPort:DWord; bOutValue:Byte): Boolean;
// aPCI-R47̴װ
function Apci47wGetLastError(wLogSlot:Word): DWord;
// ۰ذ̒l擾
function Apci47wGetSwitchValue(wLogSlot:Word; var pdwSwitchValue:DWord): Boolean;

//-------------------------------------
// (STATIC)ϐȂ
//-------------------------------------
implementation

{$J+}	// ^t萔̕ύX\߲׎w
const
	hDLL: THandle = 0;

type
	TApci47GetVersion = function(var pdwDllVersion:DWORD; var pdwDriverVersion:DWORD): BOOL; stdcall;
	TApci47Create = function(var pwLogSlot:Word): BOOL; stdcall;
	TApci47Close = function(wLogSlot:WORD): BOOL; stdcall;
	TApci47GetResource = function(wLogSlot:WORD; var pres:TAPCI47RESOURCE): BOOL; stdcall;
	TApci47InPort = function(wLogSlot:WORD; dwLogPort:DWORD; var pbInValue:BYTE): BOOL; stdcall;
	TApci47OutPort = function(wLogSlot:WORD; dwLogPort:DWORD; bOutValue:BYTE): BOOL; stdcall;
	TApci47GetLastError = function(wLogSlot:WORD): DWORD; stdcall;
	TApci47GetSwitchValue = function(wLogSlot:WORD; var pdwSwitchValue:DWORD): BOOL; stdcall;

// DLL ߰Ċ֐ڽ̊i[ϐ
var
	pApci47GetVersion: TApci47GetVersion;
	pApci47Create: TApci47Create;
	pApci47Close: TApci47Close;
	pApci47GetResource: TApci47GetResource;
	pApci47InPort: TApci47InPort;
	pApci47OutPort: TApci47OutPort;
	pApci47GetLastError: TApci47GetLastError;
	pApci47GetSwitchValue: TApci47GetSwitchValue;

function Apci47wGetDllExportFunc: Boolean; forward;

{$J-}

//============================================================================
// 		apci47.dll۰(۰ގʹװƂ)
// 		
// ߂l  True
//				s False
//============================================================================
function Apci47wDllOpen: Boolean;
begin
	Result := False;
	if hDLL = 0 then begin
		hDLL := LoadLibrary(APCI47_DLL_NAME);
		if hDLL <> 0 then begin
			Result := Apci47wGetDllExportFunc;
			if Result <> True then
				Apci47wDllClose;			// DLL֐擾ɎŝDLL۰
		end;
	end;
end;
//============================================================================
// 		apci47.dll۰(۰ގʹװƂ)
// 		
// ߂l  True
//				s False
//============================================================================
function Apci47wDllClose: Boolean;
begin
	Result := False;
	if hDLL <> 0 then begin
		Result := FreeLibrary(hDLL);
		if Result = True then begin
			hDLL := 0;
		end;
	end;
end;
//============================================================================
// 		aPCI-R47 DLL,޲ײްްޮݔԍ擾
// 		pdwDllVersion			DLLްޮݔԍi[̈ւ߲
//				pdwDriverVersion	޲ײްްޮݔԍi[̈ւ߲
// ߂l  True
//				s False
//============================================================================
function Apci47wGetVersion(var pdwDllVersion:DWord; var pdwDriverVersion:DWord): Boolean;
begin
	Result := False;
	if hDLL <> 0 then
		Result := pApci47GetVersion(pdwDllVersion, pdwDriverVersion)
end;
//============================================================================
// 		aPCI-R47̔Cӂ޲̎gp錾
// 		pwLogSlot	 gp޲̘_ۯĔԍi[߲
// ߂l  True
//				s False
//============================================================================
function Apci47wCreate(var pwLogSlot:Word): Boolean;
begin
	Result := False;
	if hDLL <> 0 then
		Result := pApci47Create(pwLogSlot)
end;
//============================================================================
// 		aPCI-R47̔Cӂ޲̎gpJ
// 		wLogSlot ޲̘_ۯĔԍ
// ߂l  True
//				s False
//============================================================================
function Apci47wClose(wLogSlot:Word): Boolean;
begin
	Result := False;
	if hDLL <> 0 then
		Result := pApci47Close(wLogSlot)
end;
//============================================================================
// 		w޲ؿ擾
// 		wLogSlot	ؿ擾޲̘_ۯĔԍ
//				pResInfo	ؿi[\߲̂
// ߂l  True
//				s False
//============================================================================
function Apci47wGetResource(wLogSlot:Word; var pResInfo:TAPCI47RESOURCE): Boolean;
begin
	Result := False;
	if hDLL <> 0 then
		Result := pApci47GetResource(wLogSlot, pResInfo)
end;
//============================================================================
// 		Cӂ߰Ăް
// 		wLogSlot	͂޲̘_ۯĔԍ
//				dwLogPort	͂_߰
//				pbInValue ްi[̈ւ߲
// ߂l  True
//				s False
//============================================================================
function Apci47wInPort(wLogSlot:Word; dwLogPort:DWord; var pbInValue:Byte): Boolean;
begin
	Result := False;
	if hDLL <> 0 then
		Result := pApci47InPort(wLogSlot, dwLogPort, pbInValue)
end;
//============================================================================
// 		Cӂ߰Ăްo
// 		wLogSlot	o͂޲̘_ۯĔԍ
//				dwLogPort	o͂_߰
//				bOutValue o͂ް
// ߂l  True
//				s False
//============================================================================
function Apci47wOutPort(wLogSlot:Word; dwLogPort:DWord; bOutValue:Byte): Boolean;
begin
	Result := False;
	if hDLL <> 0 then
		Result := pApci47OutPort(wLogSlot, dwLogPort, bOutValue)
end;
//============================================================================
// 		aPCI-R47̴װ
// 		wLogSlot	װ޲̘_ۯĔԍ
// ߂l װ
//============================================================================
function Apci47wGetLastError(wLogSlot:Word): DWord;
begin
	if hDLL = 0 then Result := APCI47_ERR_WRAPDLL
	else Result := pApci47GetLastError(wLogSlot)
end;
//============================================================================
// 		۰ذ̒l擾
// 		wLogSlot				۰ذ̒l擾޲̘_ۯĔԍ
// 				pdwSwitchValue	۰ذ̒li[̈ւ߲
// ߂l  True
//				s False
//============================================================================
function Apci47wGetSwitchValue(wLogSlot:Word; var pdwSwitchValue:DWord): Boolean;
begin
	Result := False;
	if hDLL <> 0 then
		Result := pApci47GetSwitchValue(wLogSlot, pdwSwitchValue)
end;
//---------------------------------------------------------------------------
// 	  DLL߰Ċ֐ڽ̎擾
// 	  
// ߂l  True
//		  	s False
//---------------------------------------------------------------------------
function Apci47wGetDllExportFunc: Boolean;
begin
	Result := False;
	// Apci47GetVersion ̱ڽ擾
	pApci47GetVersion := GetProcAddress(hDLL, 'Apci47GetVersion');
	if @pApci47GetVersion = nil then Exit;
	// Apci47Create ̱ڽ擾
	pApci47Create := GetProcAddress(hDLL, 'Apci47Create');
	if @pApci47Create = nil then Exit;
	// Apci47Close ̱ڽ擾
	pApci47Close := GetProcAddress(hDLL, 'Apci47Close');
	if @pApci47Close = nil then Exit;
	// Apci47GetResource ̱ڽ擾
	pApci47GetResource := GetProcAddress(hDLL, 'Apci47GetResource');
	if @pApci47GetResource = nil then Exit;
	// Apci47InPort ̱ڽ擾
	pApci47InPort := GetProcAddress(hDLL, 'Apci47InPort');
	if @pApci47InPort = nil then Exit;
	// Apci47OutPort ̱ڽ擾
	pApci47OutPort := GetProcAddress(hDLL, 'Apci47OutPort');
	if @pApci47OutPort = nil then Exit;
	// Apci47GetLastError ̱ڽ擾
	pApci47GetLastError := GetProcAddress(hDLL, 'Apci47GetLastError');
	if @pApci47GetLastError = nil then Exit;
	// Apci47GetSwitchValue ̱ڽ擾
	pApci47GetSwitchValue := GetProcAddress(hDLL, 'Apci47GetSwitchValue');
	if @pApci47GetSwitchValue = nil then Exit;
	// SĂ DLL ߰Ċ֐ڽ擾nj
	Result := True;
end;

end.

