/*============================================================================
//	apci47s.cs
//
//	aPCI-R47
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	̿ɂׯ߰֐̎gpႪLqĂ܂B
//
//==========================================================================*/

//=========================================================================
// rh IvV̐ݒ菇܂B
//
// 1.vWFNg [vpeB] y[WJ܂B
// 2.[rh] vpeB y[WNbN܂B
// 3.[AZ[t R[h̋] `FbN {bNXIɂ܂B
//=========================================================================

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace SampleR47
{
    public partial class Apci47s : Form
    {
        static Apci47w R47w;

        public Apci47s()
        {
            InitializeComponent();
        }

        private unsafe void Apci47s_Load(object sender, EventArgs e)
        {
			short wLogSlot;				/* ޲̘_ۯĔԍi[ */
			Apci47w.Resource ri;		/* ؿ */
			int dwDllVer, dwDrvVer;
			int dwSwVal;				/* ۰ذ̒l */
			Byte cbDat;
			bool bResult;				/*  */
			String szBuf;
			int i;

			R47w = new Apci47w();
			ri   = new Apci47w.Resource();
			ri.dwMemBase		= new int[Apci47w.MAX_MEM];
			ri.dwMemLength		= new int[Apci47w.MAX_MEM];
			ri.dwMemAttrib		= new int[Apci47w.MAX_MEM];
			ri.dwIOPortBase		= new int[Apci47w.MAX_IO];
			ri.dwIOPortLength	= new int[Apci47w.MAX_IO];
			ri.dwIRQRegisters	= new int[Apci47w.MAX_IRQ];
			ri.dwIRQAttrib		= new int[Apci47w.MAX_IRQ];
			ri.dwDMALst			= new int[Apci47w.MAX_DMA];
			ri.dwDMAAttrib		= new int[Apci47w.MAX_DMA];
			ri.dwReserved1		= new int[Apci47w.MAX_RSV];

			// 
			ri.dwNumMemWindows = 0;
			for (i=0; i<Apci47w.MAX_MEM; i++) 
			{
				ri.dwMemBase[i]   = 0;
				ri.dwMemLength[i] = 0;
				ri.dwMemAttrib[i] = 0;
			}
			ri.dwNumIOPorts = 0;
			for (i=0; i<Apci47w.MAX_IO; i++) 
			{
				ri.dwIOPortBase[i]   = 0;
				ri.dwIOPortLength[i] = 0;
			}
			ri.dwNumIRQs = 0;
			for (i=0; i<Apci47w.MAX_IRQ; i++) 
			{
				ri.dwIRQRegisters[i] = 0;
				ri.dwIRQAttrib[i]    = 0;
			}
			ri.dwNumDMAs = 0;
			for (i=0; i<Apci47w.MAX_DMA; i++) 
			{
				ri.dwDMALst[i]    = 0;
				ri.dwDMAAttrib[i] = 0;
			}
			for (i=0; i<Apci47w.MAX_RSV; i++)
				ri.dwReserved1[i] = 0;

			/*-------------------------------------------------
			// ްޮݔԍ\
			// aPCI-R47 DLL,ײްްޮݔԍ擾
			//-----------------------------------------------*/
			if (R47w.GetVersion(&dwDllVer, &dwDrvVer) == false) 
			{
				ErrorMessage(Apci47w.SLOT_AUTO);
				return;
			}
			szBuf = String.Concat("Version\n",
									String.Format("DLL: 0x{0:x8}\n", dwDllVer),
									String.Format("DRV: 0x{0:x8}",   dwDrvVer));
			ResultMessage(szBuf);
			/*-------------------------------------------------
			// aPCI-R47̎gp錾
			//-----------------------------------------------*/
			wLogSlot = Apci47w.SLOT_AUTO;		/* gp޲T܂B*/
			bResult = R47w.Create(&wLogSlot);	/* ꍇA̎޲̘_ۯĔԍi[܂B*/
			if (bResult == false) 
			{				                    /* ޲܂B*/
				ErrorMessage(Apci47w.SLOT_AUTO);
				return;
			}
			szBuf = String.Concat("Created\n\n",
									String.Format("LogSlot: {0}", wLogSlot));
			ResultMessage(szBuf);
			/*-------------------------------------------------
			// ؿ۰ذ̒l擾
			//-----------------------------------------------*/
			if (R47w.GetResource(wLogSlot, ref ri) == false) 
			{
				ErrorMessage(wLogSlot);
				return;
			}
			if (R47w.GetSwitchValue(wLogSlot, &dwSwVal) == false) 
			{
				ErrorMessage(wLogSlot);
				return;
			}
			szBuf = String.Concat("Resource\n",
									String.Format("IO Address: {0:x4}h - {1:x4}h\n",
									ri.dwIOPortBase[0],
									ri.dwIOPortBase[0] + ri.dwIOPortLength[0] - 1),
									String.Format("Switch    : {0:x}h", dwSwVal));
			ResultMessage(szBuf);
			/*-------------------------------------------------
			// Port 1 ɔCӂްo
			//-----------------------------------------------*/
			cbDat = 0xaa;
			if (R47w.OutPort(wLogSlot, Apci47w.PORT_1, cbDat) == false) 
			{
				ErrorMessage(wLogSlot);
				return;
			}
			szBuf = String.Concat("Port 1 փf[^o\n",
									String.Format("Port 1 Out Data: {0:x}h", cbDat));
			ResultMessage(szBuf);
			/*-------------------------------------------------
			// Port 1 ްǂݍ
			//-----------------------------------------------*/
			cbDat = 0x00;
			if (R47w.InPort(wLogSlot, Apci47w.PORT_1, &cbDat) == false) 
			{
				ErrorMessage(wLogSlot);
				return;
			}
			szBuf = String.Concat("Port 1 f[^\n",
									String.Format("Port 1 In Data: {0:x}h", cbDat));
			ResultMessage(szBuf);
			/*-------------------------------------------------
			// aPCI-R47̎gpJ
			//-----------------------------------------------*/
			if (R47w.Close(wLogSlot) == false) 
			{
				ErrorMessage(wLogSlot);
				return;
			}
			ResultMessage("Closed");
			this.Close();
        }

		/*============================================================================
		// ʂ\
		//===========================================================================*/
		private void ResultMessage(string buf)
		{
			MessageBox.Show(buf, this.Text, 
							MessageBoxButtons.OK, MessageBoxIcon.Information);
		}

		/*============================================================================
		// װүނ\
		//===========================================================================*/
		private void ErrorMessage(short wLogSlot)
		{
			int dwRes = R47w.GetLastError(wLogSlot);
			string buf;

			switch (dwRes)
			{
				case Apci47w.ERR_WRAPDLL:
				case Apci47w.ERR_SYSTEM:
					dwRes = System.Runtime.InteropServices.Marshal.GetLastWin32Error();
					buf = String.Concat("System error\n\n", 
						String.Format("Error code: 0x{0:x8}", dwRes));
					break;

				default:
					buf = String.Concat("aPCI-R47 error\n\n",
						String.Format("Error code: 0x{0:x8}", dwRes));
					break;
			}
			MessageBox.Show(buf, this.Text, MessageBoxButtons.OK, MessageBoxIcon.Stop);
		}

    }
}