Attribute VB_Name = "Wrapper"
'============================================================================
'   aPCI-R47
'
'   Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
'
'   V1.11 Date 1999/07/30
'
'============================================================================
Option Explicit
Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long
Declare Function GetProcAddress Lib "kernel32" (ByVal hModule As Long, ByVal lpProcName As String) As Long

Global Const APCI47_DLL_NAME = "apci47.dll" ' DLL
Global Const APCI47_ERR_WRAPDLL = -1        ' ׯ߰֐װ

Dim hDLL As Long                'DLLւ

'============================================================================
'     apci47.dll۰(۰ގʹװƂ)
'     
'  ߂l  True
'         s False
'============================================================================
Function Apci47wDllOpen() As Boolean
  Apci47wDllOpen = False
  If hDLL = 0 Then
    hDLL = LoadLibrary(APCI47_DLL_NAME)
    If hDLL <> 0 Then
      Apci47wDllOpen = Apci47wGetDllExportFunc()
      If Apci47wDllOpen <> True Then
        Apci47wDllClose       ' DLL֐擾ɎŝDLL۰
      End If
    End If
  End If
End Function
'============================================================================
'     apci47.dll۰(۰ގʹװƂ)
'     
'  ߂l  True
'         s False
'============================================================================
Function Apci47wDllClose() As Boolean
  Apci47wDllClose = False
  If hDLL <> 0 Then
    If FreeLibrary(hDLL) <> 0 Then
      hDLL = 0
      Apci47wDllClose = True
    End If
  End If
End Function
'============================================================================
'     aPCI-R47 DLL,޲ײްްޮݔԍ擾
'     pdwDllVersion    DLLްޮݔԍi[
'         pdwDriverVersion ޲ײްްޮݔԍi[
'  ߂l  True
'         s False
'============================================================================
Function Apci47wGetVersion(pdwDllVersion As Long, pdwDriverVersion As Long) As Boolean
  Apci47wGetVersion = False
  If hDLL <> 0 Then
    If Apci47GetVersion(pdwDllVersion, pdwDriverVersion) <> 0 Then
      Apci47wGetVersion = True
    End If
  End If
End Function
'============================================================================
'     aPCI-R47̔Cӂ޲̎gp錾
'     pwLogSlot  gp޲̘_ۯĔԍi[
'  ߂l  True
'         s False
'============================================================================
Function Apci47wCreate(pwLogSlot As Integer) As Boolean
  Apci47wCreate = False
  If hDLL <> 0 Then
    If Apci47Create(pwLogSlot) <> 0 Then
      Apci47wCreate = True
    End If
  End If
End Function
'============================================================================
'     aPCI-R47̔Cӂ޲̎gpJ
'     wLogSlot ޲̘_ۯĔԍ
'  ߂l  True
'         s False
'============================================================================
Function Apci47wClose(ByVal wLogSlot As Integer) As Boolean
  Apci47wClose = False
  If hDLL <> 0 Then
    If Apci47Close(wLogSlot) <> 0 Then
      Apci47wClose = True
    End If
  End If
End Function
'============================================================================
'     w޲ؿ擾
'     wLogSlot ؿ擾޲̘_ۯĔԍ
'         pResInfo ؿi[\
'  ߂l  True
'         s False
'============================================================================
Function Apci47wGetResource(ByVal wLogSlot As Integer, pResInfo As APCI47RESOURCE) As Boolean
  Apci47wGetResource = False
  If hDLL <> 0 Then
    If Apci47GetResource(wLogSlot, pResInfo) <> 0 Then
      Apci47wGetResource = True
    End If
  End If
End Function
'============================================================================
'     ۰ذ̒l擾
'     wLogSlot       ۰ذ̒l擾޲̘_ۯĔԍ
'         pdwSwitchValue ۰ذ̒li[
'  ߂l  True
'         s False
'============================================================================
Function Apci47wGetSwitchValue(ByVal wLogSlot As Integer, pdwSwitchValue As Long) As Boolean
  Apci47wGetSwitchValue = False
  If hDLL <> 0 Then
    If Apci47GetSwitchValue(wLogSlot, pdwSwitchValue) <> 0 Then
      Apci47wGetSwitchValue = True
    End If
  End If
End Function
'============================================================================
'     Cӂ߰Ăް
'     wLogSlot  ͂޲̘_ۯĔԍ
'         dwLogPort ͂_߰
'         pbInValue ްi[
'  ߂l  True
'         s False
'============================================================================
Function Apci47wInPort(ByVal wLogSlot As Integer, ByVal dwLogPort As Long, pbInValue As Byte) As Boolean
  Apci47wInPort = False
  If hDLL <> 0 Then
    If Apci47InPort(wLogSlot, dwLogPort, pbInValue) <> 0 Then
      Apci47wInPort = True
    End If
  End If
End Function
'============================================================================
'     Cӂ߰Ăްo
'     wLogSlot  o͂޲̘_ۯĔԍ
'         dwLogPort o͂_߰
'         bOutValue o͂ް
'  ߂l  True
'         s False
'============================================================================
Function Apci47wOutPort(ByVal wLogSlot As Integer, ByVal dwLogPort As Long, ByVal bOutValue As Byte) As Boolean
  Apci47wOutPort = False
  If hDLL <> 0 Then
    If Apci47OutPort(wLogSlot, dwLogPort, bOutValue) <> 0 Then
      Apci47wOutPort = True
    End If
  End If
End Function
'============================================================================
'     aPCI-R47̴װ
'     wLogSlot  װ޲̘_ۯĔԍ
'  ߂l װ
'============================================================================
Function Apci47wGetLastError(ByVal wLogSlot As Integer) As Long
  If hDLL = 0 Then
    Apci47wGetLastError = APCI47_ERR_WRAPDLL
  Else
    Apci47wGetLastError = Apci47GetLastError(wLogSlot)
  End If
End Function
'---------------------------------------------------------------------------
'     DLL߰Ċ֐ڽ̎擾
'     
'  ߂l  True
'         s False
'---------------------------------------------------------------------------
Private Function Apci47wGetDllExportFunc() As Boolean
  Dim pFunc As Long
  Apci47wGetDllExportFunc = False
  ' Apci47GetVersion ̱ڽ擾
  pFunc = GetProcAddress(hDLL, "Apci47GetVersion")
  If pFunc = 0 Then Exit Function
  ' Apci47Create ̱ڽ擾
  pFunc = GetProcAddress(hDLL, "Apci47Create")
  If pFunc = 0 Then Exit Function
  ' Apci47Close ̱ڽ擾
  pFunc = GetProcAddress(hDLL, "Apci47Close")
  If pFunc = 0 Then Exit Function
  ' Apci47GetResource ̱ڽ擾
  pFunc = GetProcAddress(hDLL, "Apci47GetResource")
  If pFunc = 0 Then Exit Function
  ' Apci47InPort ̱ڽ擾
  pFunc = GetProcAddress(hDLL, "Apci47InPort")
  If pFunc = 0 Then Exit Function
  ' Apci47OutPort ̱ڽ擾
  pFunc = GetProcAddress(hDLL, "Apci47OutPort")
  If pFunc = 0 Then Exit Function
  ' Apci47GetLastError ̱ڽ擾
  pFunc = GetProcAddress(hDLL, "Apci47GetLastError")
  If pFunc = 0 Then Exit Function
  ' Apci47GetSwitchValue ̱ڽ擾
  pFunc = GetProcAddress(hDLL, "Apci47GetSwitchValue")
  If pFunc = 0 Then Exit Function
  Apci47wGetDllExportFunc = True    ' SĂ DLL ߰Ċ֐ڽ擾
End Function



